var map;
var trafficLayer;
var zoomLastVal;
var carMarkerArr=[];
var bounds;
var noticeMarkers=[];
function initMap() {
    try {
        map = new google.maps.Map(document.getElementById('map'), {
            zoom: 8
        });
        zoomLastVal=map.getZoom();
        trafficLayer = new google.maps.TrafficLayer();
        map.addListener('zoom_changed', function(e) {
            if(zoomLastVal<map.getZoom() && zoomLastVal!=0){
                my_zoom_in_trigger();
            }else{
                my_zoom_out_trigger();
            }
            my_zoom_changed();
        });
        map.addListener('click', function() {
            ToggleWithScrooll();
        });
        bounds = new google.maps.LatLngBounds();
    }catch(err) {
        alert("Sayfa yüklenemedi :"+err.message);
    }
}
function map_maps_on(){
    map.setMapTypeId(google.maps.MapTypeId.ROADMAP );
    $('.map_maps_on').hide();
    $('.map_sattalite_on').show();
}
function map_sattalite_on(){
    map.setMapTypeId(google.maps.MapTypeId.HYBRID);
    $('.map_sattalite_on').hide();
    $('.map_maps_on').show();
}
function loadCars(){
	$.post(getDefine("baseURL")+"/mobilservice/ajax.php?act=tumaraclar", { tokenx: tokenx.tokenx})
	  .done(function( data ) {
	       var tumaraclar = JSON.parse(data);
            for(var i=0;i<tumaraclar.length;i++){
                createMarker(i,tumaraclar[i].ID,tumaraclar[i].LT,tumaraclar[i].LG,tumaraclar[i].ST,tumaraclar[i].RT,tumaraclar[i].P);
                
                google.maps.event.addListener(carMarkerArr[i]["MARK"], 'click', function() {
                    locationCarMaps(this.ID);
        	    });
            }
            map.fitBounds(bounds);
	  }).error(function(xhr, textStatus, errorThrown) {
            alert('Bağlantı kurulamadı. İnternet bağlantınızı kontrol edip tekrar deneyiniz.'+xhr.responseText);
      });
}
function getCar(id){
	$.post(getDefine("baseURL")+"/mobilservice/ajax.php?act=arac", { tokenx: tokenx.tokenx,carID:id})
	  .done(function( data ) {
	       if(!isEmpty(data)){
	            zoomLastVal=0;
                var arac = JSON.parse(data);
                $('plk').html(arac.P);
                createMarker(0,arac.ID,arac.LT,arac.LG,arac.ST,arac.RT,"");
                if($('#focus-bt').is(':checked')){
                    map.fitBounds(bounds);
                }
                map.setZoom(15);
                map.setCenter(new google.maps.LatLng(arac.LT, arac.LG));
                infoWindow(arac);
	       }
	  }).error(function(xhr, textStatus, errorThrown) {
            alert('Bağlantı kurulamadı. İnternet bağlantınızı kontrol edip tekrar deneyiniz.'+xhr.responseText);
      });
}
function infoWindow(arac){
    $('#trc-adress').html(arac.LK);
    $('#speed').html(arac.SP);
    $('#trc-sonveri').html(arac.KT);
    $('#trc-arackm').html(arac.MS);
    $('#trc-gunkm').html(arac.DD);
    $('#trc-bekleme').html(arac.PT);
    $('#trc-sofor').html(arac.DR);
    
    if(statusBlockCntrl(arac.DRM2)){
        showUnBlockBt();
    }else{
        showBlockBt();
    }   
    $('#bt-diagnostic').attr('PERMDIAG',arac.PERMDIAG);
    if(arac.CN=="1"){
        //$('#field-diagnostic').show();
        $('#diag-date').html(arac.DRD);
        $('#diag-speed').html(arac.DSP);
        $('#diag-distance').html(arac.DHD);
        $('#diag-turnover').html(arac.DTO);
        $('#diag-fuel-level').html(arac.DFI);
        $('#diag-fuel-daily').html(arac.DFD);
        $('#diag-fuel-avg').html(arac.DFA);
        $('#diag-fuel-total').html(arac.DFT);
        $('#diag-engine-temp').html(arac.DET);
        $('#diag-distance-daily').html(arac.DTR);
    }else{
        $('#field-diagnostic').hide();
    }
}
function getCarLocate(id,blockCntrl){
	$.post(getDefine("baseURL")+"/mobilservice/ajax.php?act=arac", { tokenx: tokenx.tokenx,carID:id})
	  .done(function( data ) {
	       if(!isEmpty(data)){
	            zoomLastVal=0;
                var arac = JSON.parse(data);
                if(isEmpty(carMarkerArr))
                    createMarker(0,arac.ID,arac.LT,arac.LG,arac.ST,arac.RT,"");
                else
                    updateMarker(0,arac.LT,arac.LG,arac.ST,arac.RT,"");
                if($('#focus-bt').is(':checked')){
                    map.setCenter(new google.maps.LatLng(arac.LT, arac.LG));
                }
                if(blockCntrl==true){
                    infoWindow(arac);
                    if(statusBlockCntrl(arac.DRM2)){
                        showUnBlockBt();
                    }else{
                        showBlockBt();
                    }
                }
	       }
	  }).error(function(xhr, textStatus, errorThrown) {
            alert('Bağlantı kurulamadı. İnternet bağlantınızı kontrol edip tekrar deneyiniz.'+xhr.responseText);
      });
}
function statusBlockCntrl(STATUS){
	if (STATUS.substr(7,1)==1 || STATUS.substr(5,1)==1){//Araç Blokeli
	   return true;
	}else{
	   return false;
	}
}

function updateCars(){
	$.post(getDefine("baseURL")+"/mobilservice/ajax.php?act=tumaraclar", { tokenx: tokenx.tokenx})
	  .done(function( data ) {
            var tumaraclar = JSON.parse(data);
            for(var i=0;i<tumaraclar.length;i++){
                updateMarker(i,tumaraclar[i].LT,tumaraclar[i].LG,tumaraclar[i].ST,tumaraclar[i].RT);
            }
	  }).error(function(xhr, textStatus, errorThrown) {
            alert('Bağlantı kurulamadı. İnternet bağlantınızı kontrol edip tekrar deneyiniz.'+xhr.responseText);
      });
}
function createMarker(i,ID,LT,LG,ST,RT,P){
    try{
        var position = new google.maps.LatLng(LT,LG);
        carMarkerArr[i] = {
            "MARK": new MarkerWithLabel({
               position: position,
               draggable: false,
               map: map,
               labelContent: P,
               icon: generateMarker(ST,RT),
               labelAnchor: new google.maps.Point(20, 40),
               labelClass: "labels", // the CSS class for the label
               labelStyle: {opacity: 0.6},
               labelClass:"plate-number",
               "ID": ID,
            })
        };
        bounds.extend(position);
    }catch(err){
        //window.location.reload();
    }
}
function clearMarkers() {
  for (var i = 0; i < markers.length; i++) {
    carMarkerArr[i]["MARK"].setMap(null);
  }
}
function updateMarker(ID,LT,LG,ST,RT){
    carMarkerArr[ID]["MARK"].setPosition(new google.maps.LatLng(LT,LG));
    carMarkerArr[ID]["MARK"].setIcon(generateMarker(ST,RT));
}

function trafficLayerOn(){
    trafficLayer.setMap(map);
    $(".trafficOn").hide();
    $(".trafficOff").show();
}
function trafficLayerOff(){
    trafficLayer.setMap(null);
    $(".trafficOn").show();
    $(".trafficOff").hide();
}
function play(){
    $(".play").hide();
    $(".pause").show();
    playRecord();
}
function pause(){
    $(".pause").hide();
    $(".play").show();
    pauseRecord();
}
function my_zoom_changed(){
    zoomLastVal=map.getZoom();
}
function my_zoom_in_trigger(){
    //hideWithScrooll();
}
function my_zoom_out_trigger(){
    //showWithScrooll();
}
function generateMarker(ST,RT){
    return {
            path: GLOBAL_ICONS[ST].icon,
            scale: 9,
            rotation: parseInt(RT),
            fillColor: GLOBAL_ICONS[ST].color,
            strokeColor: GLOBAL_ICONS[ST].color,
            fillOpacity: 1,
            strokeWeight: 0.1
          };
}

// Adds a marker to the map and push to the array.
function addMarker(position,title,content) {
    var marker = new google.maps.Marker({
        position: position,
        animation: google.maps.Animation.DROP,
        icon: "images/warning.png?v=3",
        map: map,
        title: title
    });
    
    var contentString = '<div id="content">'+
      '<div id="siteNotice">'+
      '</div>'+
      '<h1 id="firstHeading" class="firstHeading">'+title+'</h1>'+
      '<div id="bodyContent">'+
      '<p>'+content+'</p>'+
      '</div>'+
      '</div>';
    
    var infowindow = new google.maps.InfoWindow({
        content: contentString
    });
    marker.addListener('click', function() {
        infowindow.open(map, marker);
    });
    window.setTimeout(function() {
        noticeMarkers.push(marker);
    }, 1000);
}

// Sets the map on all markers in the array.
function setMapOnAll(map) {
  for (var i = 0; i < noticeMarkers.length; i++) {
    noticeMarkers[i].setMap(map);
  }
}

// Removes the markers from the map, but keeps them in the array.
function clearNotice() {
  setMapOnAll(null);
}

// Shows any markers currently in the array.
function showNotice() {
  setMapOnAll(map);
}

// Deletes all markers in the array by removing references to them.
function deleteNotice() {
  clearNotice();
  noticeMarkers = [];
}
function map_zoom_in(){
    map.setZoom(map.getZoom()+1);
}
function map_zoom_out(){
    map.setZoom(map.getZoom()-1);
}
var circle=null;
var circMarker=null;
var LocateTimer;
var onSuccess = function(position) {
//    alert('Latitude: '          + position.coords.latitude          + '\n' +
//          'Longitude: '         + position.coords.longitude         + '\n' +
//          'Altitude: '          + position.coords.altitude          + '\n' +
//          'Accuracy: '          + position.coords.accuracy          + '\n' +
//          'Altitude Accuracy: ' + position.coords.altitudeAccuracy  + '\n' +
//          'Heading: '           + position.coords.heading           + '\n' +
//          'Speed: '             + position.coords.speed             + '\n' +
//          'Timestamp: '         + position.timestamp                + '\n');
//          
    var locate = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
    if(circle==null){
        circle = new google.maps.Circle({
            center: locate,
            radius: position.coords.accuracy,
            map: map,//your map,
            fillColor: "#000",//color,
            fillOpacity: 0.2,//opacity from 0.0 to 1.0,
            strokeColor: "#A9A9F5",//stroke color,
            strokeOpacity: 0.9//opacity from 0.0 to 1.0
        });
        circMarker = new google.maps.Marker({
            position: locate,
            icon: GLOBAL_ICONS["10"],
            map: map
        });
        
        map.fitBounds(circle.getBounds());
    }else{
        circle.setCenter(locate);
        circMarker.setPosition(locate)
        circle.setRadius(position.coords.accuracy);
    }
};
// onError Callback receives a PositionError object
//
function onError(error) {
    alert('Üzgünüz bir hata oluştu: code: '    + error.code    + '\n' +
          'message: ' + error.message + '\n');
}
function updateLocate(){
    myLocateShow();
    LocateTimer = window.setTimeout(function(){updateLocate();},10000);
}

function startTrackingMyLocate(){
    updateLocate();
    $('.bt-psf-locate').hide();
    $('.bt-act-locate').show();
}
function stopTrackingMyLocate(){
    clearTimeout(LocateTimer);
    circle.setMap(null);
    circMarker.setMap(null);
    circMarker=null;
    circle=null;
    $('.bt-psf-locate').show();
    $('.bt-act-locate').hide();
}

function myLocateShow(){
    navigator.geolocation.getCurrentPosition(onSuccess, onError);
}
function myLocateClose(){
    
}

